Installation/Compatibility Matrix

From OpenFOAMWiki

1 Introduction

This page aims to keep track of the versions of third-party applications vs OpenFOAM versions/variants.

If you have specific questions that are not answered here, please use the related forum thread: New wiki page: Compatibility Matrix of OpenFOAM vs third party applications


2 OpenFOAM Foundation

Official websites:

2.1 GNU Compiler Collection (GCC)

Description
This is the standard compiler currently used by Linux distributions, as well as the usual one used for OpenFOAM.
Website
GCC, the GNU Compiler Collection
Compatibility matrix
OpenFOAM \ GCC 4.2.y 4.3.y 4.4.y 4.5.y 4.6.y 4.7.y 4.8.y 4.9.y 5.y 6.y
OF version 15.png unknown y=3,4,... none none none none none none none none
OF Version 15x.png unknown y=3,4,... none none none none none none none none
OF version 16.png none y=3,4,... none none none none none none none none
OF Version 16x.png none y=3,4,... all none none none none none none none
OF Version 170.png none y=3,4,... all none none none none none none none
OF Version 171.png none y=3,4,... all all none [1] none none none none none
OF Version 17x.png none y=3,4,... all all unconfirmed none none none none none
OF Version 200.png none y=3,4,... all all unconfirmed unconfirmed none none none none
OF Version 201.png none y=3,4,... all all unconfirmed unconfirmed none none none none
OF Version 20x.png none y=3,4,... all all all unconfirmed none none none none
OF Version 210.png none y=3,4,... all all all unconfirmed none none none none
OF Version 211.png none y=3,4,... all all all all none none none none
OF Version 21x.png none y=3,4,... all all all all unconfirmed unknown none none
OF Version 220.png none none none [2] all all all unconfirmed unknown unknown none
OF Version 221.png none none none [2] all all all all unknown unknown none
OF Version 222.png none none none [2] all all all all unknown unknown none
OF Version 22x.png none none none [2] all all all all unknown unknown none
OF Version 230.png none none none all all all all [3] all unknown none
OF Version 231.png none none none all all all all [3] all all none
OF Version 23x.png none none none all all all all [3] all all none
OF Version 240.png OF Version 24x.png none none none all all all all [3] all all none [4]
OF Version 300.png OF Version 301.png OF Version 30x.png none none none all all all all all all unknown
OF Version 40.png OF Version 4x.png none none none all all all all all all all
OF Version FoundationDev.png none none none none none none [5] all all all all

Note: unconfirmed indicates that although it might build, it doesn't mean that it will work as intended.

  1. Proof of concept available on this thread: OpenFOAM 1.7.1 and gcc 4.6.3: scalarField no bounds check?.
  2. 2.0 2.1 2.2 2.3 Possible with the details provided on this thread: Compile Error of OpenFOAM-2.2.0 on RedHat EL5.
  3. 3.0 3.1 3.2 3.3 Building CGAL might have issues with a custom build of GCC 4.8.2, as explained on this bug report.
  4. See post #6 in the thread [OpenFOAM][2.4.0] Error in the building of ParaView 4.1.0 for some more information on what needs fixing to get GCC 6.y to be usable.
  5. On the 5th of August 2016, in commit 618753c5b4, was marked the change regarding explicit support for C++11. More details given in the commit description, but 4.8 is the recommended minimum version. Furthermore, as commented in issue #2230, GCC 4.7 cannot be used any more to build OpenFOAM-dev.



2.2 Intel C++ Compiler (ICC)

Description
This compiler is free for non-commercial users on Linux. Yields good/very good performance on Intel processors.
Comments
Latest GCC versions (4.5.0 and above) have been proven themselves to be on par or better than ICC.
It's not advisable to use ICC on non-Intel (AMD, Via, etc) machines - source: ICC on Wikipedia, section Criticism. But it's possible to use it if the option -SSE3 is not used:
Website
Intel® Compilers
Overcoming compatibility issues
Intel Compiler 12.1 + Ubuntu 11.10 (gcc 4.6) + OpenFOAM 2.0.x
Compatibility matrix
OpenFOAM \ ICC 10.y 11.y 12.y 13.y 14.y 15.y 16.y
OF version 15.png unknown unknown unknown unknown unknown unknown unknown
OF Version 15x.png unknown unknown unknown unknown unknown unknown unknown
OF version 16.png untested [1] unknown unknown unknown unknown unknown unknown
OF Version 16x.png untested [1] unknown unknown unknown unknown unknown unknown
OF Version 170.png unknown 11.1 unknown unknown unknown unknown unknown
OF Version 171.png unknown 11.1 all [2] unknown unknown unknown unknown
OF Version 17x.png unknown 11.1 all [3] unknown unknown unknown unknown
OF Version 200.png none none [4] 12.1 unknown unknown unknown unknown
OF Version 201.png none none 12.1 [5] unknown unknown unknown unknown
OF Version 20x.png none none 12.1 unknown unknown unknown unknown
OF Version 210.png none none 12.1 unknown unknown unknown unknown
OF Version 21x.png none none 12.1 unknown unknown unknown unknown
OF Version 21x.png none none 12.1 unknown unknown unknown unknown
OF Version 220.png none none 12.1 13.1 unknown unknown unknown
OF Version 221.png none none 12.1 13.1 unknown unknown unknown
OF Version 222.png none none 12.1 13.1 unknown unknown unknown
OF Version 22x.png none none 12.1 13.1 unknown unknown unknown
OF Version 230.png none none unknown unknown 14.0.1 unknown unknown
OF Version 231.png none none unknown unknown 14.0.1 unknown unknown
OF Version 23x.png none none unknown unknown 14.0.1 unknown unknown
OF Version 240.png OF Version 24x.png none none unknown unknown 14.0.1 unknown unknown
OF Version 300.png OF Version 30x.png none none none none none 15.0.3 unknown
OF Version FoundationDev.png none none none none none 15.0.3 [6] 16.0.3 [6]
  1. 1.0 1.1 According to the release notes for OpenFOAM 1.6, this hasn't been tested.
  2. Needs bug fix, provided in this bug report.
  3. Bug has been fixed.
  4. See related bug report.
  5. See bug report for the necessary fix.
  6. 6.0 6.1 Introduced support for 16.0.3 in commit 4f6117e973. Should still work with 15.0.3.


3 OpenFOAM Extend Project

Extend Project websites:

3.1 GNU Compiler Collection (GCC)

Description
This is the standard compiler currently used by Linux distributions, as well as the usual one used for OpenFOAM.
Website
GCC, the GNU Compiler Collection
Compatibility matrix
OpenFOAM \ GCC 4.2.y 4.3.y 4.4.y 4.5.y 4.6.y 4.7.y 4.8.y 4.9.y 5.y
OF Version 14dev.png unknown y=3,4,... unknown unknown none none none none none
OF Version 15dev.png unknown y=3,4,... unknown unknown none none none none none
OF Version 16ext.png unknown y=3,4,... all all all all[1] unknown unknown unknown
OF Version 30ext.png unknown unknown unknown all all all unknown unknown unknown
OF Version 31ext.png unknown unknown unknown all all all unknown unknown unknown
OF Version 32ext.png unknown unknown unknown unknown unknown[2] all all all unknown


  1. Compiling with GCC 4.7 requires two details: having the latest 1.6-ext commit, as well as a couple of hacks to make sure that things build as intended. Both can indications can be found in the instructions of installing 1.6-ext on Ubuntu 13.04, which uses GCC 4.7.3.
  2. Compiling with GCC 4.6.3 might be very slow and it could potentially have problems in running in some cases. This has been witnessed at least with Ubuntu 12.04. For more details:


4 FreeFOAM

FreeFOAM websites:

See the ChangeLog or the version control history.